/**
 * \file /output/ods/ptm/ptmspectrasheet.cpp
 * \date 16/2/2018
 * \author Olivier Langella
 * \brief ODS PTM spectra sheet
 */

/*******************************************************************************
* Copyright (c) 2018 Olivier Langella <olivier.langella@u-psud.fr>.
*
* This file is part of XTPcpp.
*
*     XTPcpp is free software: you can redistribute it and/or modify
*     it under the terms of the GNU General Public License as published by
*     the Free Software Foundation, either version 3 of the License, or
*     (at your option) any later version.
*
*     XTPcpp is distributed in the hope that it will be useful,
*     but WITHOUT ANY WARRANTY; without even the implied warranty of
*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*     GNU General Public License for more details.
*
*     You should have received a copy of the GNU General Public License
*     along with XTPcpp.  If not, see <http://www.gnu.org/licenses/>.
*
* Contributors:
*     Olivier Langella <olivier.langella@u-psud.fr> - initial API and implementation
******************************************************************************/

#include "ptmspectrasheet.h"


PtmSpectraSheet::PtmSpectraSheet (OdsExport * p_ods_export, CalcWriterInterface * p_writer, const Project * p_project): SpectraSheet(p_ods_export, p_writer, p_project, QString("PTM spectra")) {
    qDebug() << "PtmSpectraSheet::PtmSpectraSheet begin" ;
    qDebug() << "PtmSpectraSheet::PtmSpectraSheet end" ;
}

void PtmSpectraSheet::writeIdentificationGroup(IdentificationGroup * p_ident) {
    _p_ptm_grouping_experiment = p_ident->getPtmGroupingExperiment();
    
    
    qDebug() << "PtmIslandSheet::writeIdentificationGroup getPtmIslandList" ;
    std::vector<PtmIslandSp> ptm_island_list;
    for (auto ptm_island_sp : _p_ptm_grouping_experiment->getPtmIslandList() ) {
        qDebug() << "PtmIslandSheet::writeIdentificationGroup getPtmIslandList copy" ;
        ptm_island_list.push_back(ptm_island_sp);
    }
    qDebug() << "PtmIslandSheet::writeIdentificationGroup sort" ;
    std::sort(ptm_island_list.begin(), ptm_island_list.end(),
              [](PtmIslandSp & a, PtmIslandSp & b)
    {
        return a.get()->getGroupingId() < b.get()->getGroupingId();
    });

    qDebug() << "PtmIslandSheet::writeIdentificationGroup 2" ;
    for (auto & ptm_island:ptm_island_list) {
        writeOnePtmIsland(ptm_island);
    }
}
